import base64
import gettext
import os
import re, gi
import subprocess
import json
gi.require_version('Gtk', '3.0')

from gi.repository import Gtk
from share_directory.common import *
# from common import *

t = gettext.translation('share_directory', "/usr/share/locale/")
t.install()
_ = t.gettext

# builder = Gtk.Builder()
# builder_ad.add_from_file('./data/templates.glade')

def make_dict(lst):
    if len(lst) == 1:
        return {lst[0]: ''}
    else:
        it = reversed(lst)
        d = next(it)
        first = True
        for n in it:
            if first:
                d = {n: {d: ''}}
                first = False
            else:
                d = {n: d}
        return d

def mergedicts(dict1, dict2):
    for k in set(dict1.keys()).union(dict2.keys()):
        if k in dict1 and k in dict2:
            if isinstance(dict1[k], dict) and isinstance(dict2[k], dict):
                yield (k, dict(mergedicts(dict1[k], dict2[k])))
            else:
                yield (k, dict2[k])
        elif k in dict1:
            yield (k, dict1[k])
        else:
            yield (k, dict2[k])

def export_ou():
    server_name = os.popen(
            "adcli info " + get_domain_name() + " | grep 'domain-controller ='| awk '{print $3}'").readline().strip()
    dc_separated = ''
    dc_server_name = server_name.split(".")
    for d in dc_server_name[1:]:
        dc_separated += f'dc={d},'
    dc_separated = dc_separated[:-1]
    outp = subprocess.Popen(['ldapsearch', '-Y', 'GSSAPI', '-H', f'ldap://{server_name}', '-b', f'{dc_separated}',
                             '(&(objectCategory=organizationalUnit))', 'name', '-LLL', "-o", "ldif-wrap=no"],
                            stdout=subprocess.PIPE,
                            stderr=subprocess.PIPE)
    output, error = outp.communicate()
    lines = output.decode("utf-8").split("\n")
    para = []
    for i in range(0, len(lines)):
        if "dn:" in lines[i]:
            para.append([lines[i], lines[i + 1]])
    clear_para = {}
    for p in para:
        if "dn: " in p[0]:
            key = re.sub("dn: ", "", p[0])
        elif "dn:: " in p[0]:
            key = base64.b64decode(re.sub("dn:: ", "", p[0])).decode('utf8')
        if "name: " in p[1]:
            value = re.sub("name: ", "", p[1])
        elif "name:: " in p[1]:
            value = base64.b64decode(re.sub("name:: ", "", p[1])).decode('utf8')
        clear_para[key.strip()] = value.strip()
    dict_para = []
    for p in clear_para:
        k = p.split(",")
        mas = []
        for o in k:
            if o.startswith("ou=") or o.startswith("OU="):
                o = re.sub("ou=", "", o)
                o = re.sub("OU=", "", o)
                mas.append(o)
        dict_para.append(mas)
    if len(dict_para) > 0:
        m = dict_para[0]
        m.reverse()
        final_dict = make_dict(m)
        for i in range(1, len(dict_para)):
            m = dict_para[i]
            m.reverse()
            temp_dict = make_dict(m)
            final_dict = dict(mergedicts(final_dict, temp_dict))
    return final_dict


def export_conts():
    server_name = os.popen(
            "adcli info " + get_domain_name() + " | grep 'domain-controller ='| awk '{print $3}'").readline().strip()
    dc_separated = ''
    dc_server_name = server_name.split(".")
    for d in dc_server_name[1:]:
        dc_separated += f'dc={d},'
    dc_separated = dc_separated[:-1]
    outp = subprocess.Popen(['ldapsearch', '-Y', 'GSSAPI', '-H', f'ldap://{server_name}', '-b', f'{dc_separated}',
                             '(&(objectCategory=container)(showInAdvancedViewOnly=FALSE))', 'name', '-LLL', "-o", "ldif-wrap=no"],
                            stdout=subprocess.PIPE,
                            stderr=subprocess.PIPE)
    output, error = outp.communicate()
    if "GSSAPI Error" in error.decode("utf-8").strip():
        win = InfoClass()
        win.print_error(error.decode("utf-8").strip(), dbus_mode=True)
        os.system("kill -9 $(ps aux | grep '[s]hare-directory$' | awk '{print $2}')")

    lines = output.decode("utf-8").split("\n")
    para = []
    for i in range(0, len(lines)):
        if "dn:" in lines[i]:
            para.append([lines[i], lines[i + 1]])
    clear_para = {}
    for p in para:
        if "dn: " in p[0]:
            key = re.sub("dn: ", "", p[0])
        elif "dn:: " in p[0]:
            key = base64.b64decode(re.sub("dn:: ", "", p[0])).decode('utf8')
        if "name: " in p[1]:
            value = re.sub("name: ", "", p[1])
        elif "name:: " in p[1]:
            value = base64.b64decode(re.sub("name:: ", "", p[1])).decode('utf8')
        clear_para[key.strip()] = value.strip()
    dict_para = []
    for p in clear_para:
        k = p.split(",")
        mas = []
        for o in k:
            if o.startswith("CN=") or o.startswith("cn="):
                o = re.sub("cn=", "", o)
                o = re.sub("CN=", "", o)
                mas.append(o)
        dict_para.append(mas)
    if len(dict_para) > 0:
        m = dict_para[0]
        m.reverse()
        final_dict = make_dict(m)

        for i in range(1, len(dict_para)):
            m = dict_para[i]
            m.reverse()
            temp_dict = make_dict(m)
            final_dict = dict(mergedicts(final_dict, temp_dict))
    return final_dict

jsonpath_unquoted_property_regex = re.compile(r"^[a-zA-Z][a-zA-Z0-9_]*$")

def get_domain_name():
    output = os.popen("hostname -d").readlines()[0].strip()
    return output

class JSONTreeStore(Gtk.TreeStore):
    """A tree-like data structure that can be used with the JSONTreeView."""
    def __init__(self, type_key):
        super().__init__(str, str)
        self.type_key = type_key
        self.color_array = "#e5a50a"  # Yellow
        self.color_type = "#c64600"  # Orange
        self.color_string = "#613583"  # Purple
        self.color_number = "#a51d2d"  # Red
        self.color_object = "#1a5fb4"  # Blue
        self.color_key = "#00a305"  # Green
    def walk_tree(self, data, parent=None):
        if isinstance(data, dict):
            for key in sorted(data):
                self._add_item(key, data[key], parent)
        else:
            self._add_item(None, data, parent)

    def _add_item(self, key, data, parent=None):
        if isinstance(data, dict):
            if key is not None:
                obj = self.append(parent, [self._format_item(self.color_object, self.color_type, str(key), ""),
                        f"{self.get_value(parent, 1)},{self.type_key}={str(key)}"]) if parent else \
                    self.append(parent, [self._format_item(self.color_object, self.color_type, str(key), ""),
                        f"{self.type_key}={str(key)}"])
                self.walk_tree(data, obj)
            else:
                self.walk_tree(data, parent)

        elif isinstance(data, str):
            if len(data) > 256:
                data = data[0:255] + " <i>…</i> "
                if key is not None:
                    item = self._format_item(
                        self.color_key, self.color_string, key, data
                    )
                    self.append(parent, [item, f"{self.get_value(parent, 1)},{self.type_key}={str(key)}"])
            else:
                if key is not None:
                    item = self._format_item(
                        self.color_key, self.color_string, key, ""
                    )
                    new_iter = self.append(parent, [item, f"{self.get_value(parent, 1)},{self.type_key}={str(key)}"]) if parent else \
                        self.append(parent, [item, f"{self.type_key}={str(key)}"])
                    if data != "":
                        item = self._format_item(
                            self.color_key, self.color_string, "", data
                        )
                        self.append(new_iter, [item, f"{self.get_value(new_iter, 1)},{self.type_key}={str(data)}"])
        else:
            print(
                "Warning: do not know how to format {} of type {}".format(str(data)),
                data.__class__.__name__,
            )

    def _format_item(self, color_key, color_value, key, value):
        outp = ""
        if key != "" and value == "":
            outp = '<span foreground="{}">{}</span>'.format(color_key, key)
        elif key == "" and value != "":
            outp = '<span foreground="{}">{}</span>'.format(color_value, value)
        return outp

class UserandGroupViewer:
    def __init__(self, path=None):
        super(UserandGroupViewer, self).__init__()
        self.builder_ad = Gtk.Builder()
        self.builder_ad.add_from_file('/usr/share/share_directory/ui/templates.glade')
        # self.builder_ad.add_from_file('/home/wolandius/git_projects/share_directory/data/templates.glade')
        self.builder_ad.set_translation_domain("share_directory")
        self.window = self.builder_ad.get_object("user_and_gropus_list_window")
        self.ou_treeview = self.builder_ad.get_object("ou_treeview")
        self.container_treeview = self.builder_ad.get_object("container_treeview")
        self.save_button_access_window = self.builder_ad.get_object("save_button_access_window")
        self.save_button_access_window.connect("clicked", self.on_save_button_access_window_clicked)
        self.path = path
        model_containers = JSONTreeStore("CN")
        model_containers.walk_tree(export_conts())
        self.server_name = os.popen(
            "adcli info " + get_domain_name() + " | grep 'domain-controller ='| awk '{print $3}'").readline().strip()
        cell_cont = Gtk.CellRendererText()
        self.column_container = Gtk.TreeViewColumn(f"{self.server_name}", cell_cont, markup=0)
        self.container_treeview.append_column(self.column_container)
        self.container_treeview.set_model(model_containers)
        self.container_treeview.set_enable_tree_lines(True)
        self.container_treeview.get_selection().connect("changed", self.__get_selection)
        model_ou = JSONTreeStore("OU")
        if not os.path.exists("/tmp/share_directory/users"):
            os.makedirs("/tmp/share_directory/users")
        if not os.path.exists("/tmp/share_directory/groups"):
            os.makedirs("/tmp/share_directory/groups")        
        model_ou.walk_tree(export_ou())
        cel_ou = Gtk.CellRendererText()
        self.column_ou = Gtk.TreeViewColumn(f"{self.server_name}", cel_ou, markup=0)
        self.ou_treeview.append_column(self.column_ou)
        self.ou_treeview.set_model(model_ou)
        self.ou_treeview.set_enable_tree_lines(True)
        self.ou_treeview.get_selection().connect("changed", self.__get_selection)
        self.uzvers_treeview = self.builder_ad.get_object("uzverslist_treeview")
        self.groupslist_treeview = self.builder_ad.get_object("groupslist_treeview")
        domain_users = _("Domain users")
        domain_groups = _("Domain groups")
        access_allowed = _("Access allowed")
        read = _("Read")
        write = _("Write")
        renderer_text = Gtk.CellRendererText()
        self.column = Gtk.TreeViewColumn(domain_users, renderer_text, markup=0)
        self.uzvers_treeview.append_column(self.column)

        renderer_toggle = Gtk.CellRendererToggle()
        renderer_toggle.set_radio(True)
        renderer_toggle.connect("toggled", self.on_cell_user_toggled_liststore, 1)

        column_toggle = Gtk.TreeViewColumn(access_allowed, renderer_toggle, active=1)
        column_toggle.set_alignment(0.5)
        self.uzvers_treeview.append_column(column_toggle)

        renderer_toggle = Gtk.CellRendererToggle()
        renderer_toggle.set_radio(True)
        renderer_toggle.connect("toggled", self.on_cell_user_toggled_liststore, 2)

        column_toggle = Gtk.TreeViewColumn(read, renderer_toggle, active=2)
        column_toggle.set_alignment(0.5)
        self.uzvers_treeview.append_column(column_toggle)

        renderer_toggle = Gtk.CellRendererToggle()
        renderer_toggle.set_radio(True)
        renderer_toggle.connect("toggled", self.on_cell_user_toggled_liststore, 3)

        column_toggle = Gtk.TreeViewColumn(write, renderer_toggle, active=3)
        column_toggle.set_alignment(0.5)
        self.uzvers_treeview.append_column(column_toggle)

        renderer_text = Gtk.CellRendererText()
        self.column = Gtk.TreeViewColumn(domain_groups, renderer_text, markup=0)
        self.groupslist_treeview.append_column(self.column)

        renderer_toggle = Gtk.CellRendererToggle()
        renderer_toggle.set_radio(True)
        renderer_toggle.connect("toggled", self.on_cell_group_toggled_liststore, 1)

        column_toggle = Gtk.TreeViewColumn(access_allowed, renderer_toggle, active=1)
        column_toggle.set_alignment(0.5)
        self.groupslist_treeview.append_column(column_toggle)

        renderer_toggle = Gtk.CellRendererToggle()
        renderer_toggle.set_radio(True)
        renderer_toggle.connect("toggled", self.on_cell_group_toggled_liststore, 2)

        column_toggle = Gtk.TreeViewColumn(read, renderer_toggle, active=2)
        column_toggle.set_alignment(0.5)
        self.groupslist_treeview.append_column(column_toggle)

        renderer_toggle = Gtk.CellRendererToggle()
        renderer_toggle.set_radio(True)
        renderer_toggle.connect("toggled", self.on_cell_group_toggled_liststore, 3)

        column_toggle = Gtk.TreeViewColumn(write, renderer_toggle, active=3)
        column_toggle.set_alignment(0.5)
        self.groupslist_treeview.append_column(column_toggle)

        self.users_list = Gtk.ListStore(str, bool, bool, bool, bool)
        self.groups_list = Gtk.ListStore(str, bool, bool, bool, bool)

        self.entry_uzver = self.builder_ad.get_object("entry_uzver")
        self.entry_group = self.builder_ad.get_object("entry_group")

        self.filter_uzvers = self.users_list.filter_new()
        self.filter_groups = self.groups_list.filter_new()

        self.filter_uzvers.set_visible_func(self.visible_names_uzver)
        self.filter_groups.set_visible_func(self.visible_names_groups)

        self.uzver_id = self.entry_uzver.connect("changed", self.refresh_filter_uzver)
        self.group_id = self.entry_group.connect("changed", self.refresh_filter_group)

        self.uzvers_treeview.set_model(self.filter_uzvers)
        self.groupslist_treeview.set_model(self.filter_groups)
        self.window.show_all()
    def on_save_button_access_window_clicked(self, button):
        self.window.destroy()
    def on_cell_user_toggled_liststore(self, widget, path, index):
        self.uzvers_treeview.set_cursor(path)
        model, iter = self.uzvers_treeview.get_selection().get_selected()
        model[iter][index] = not model[iter][index]
        for i in range(0, len(self.users_list)):
            if self.users_list[i][0] == model[iter][0]:
                self.users_list[i][index] = model[iter][index]
                with open(f"/tmp/share_directory/users/{self.extra_path}.json") as f:
                    data = json.load(f)
                    for user in data:
                        for key in user:
                            if key == model[iter][0]:
                                user[key][index-1] = self.users_list[i][index]

                with open(f'/tmp/share_directory/users/{self.extra_path}.json', 'w') as f:
                    json.dump(data, f)

    def refresh_filter_uzver(self, widget):
        self.filter_uzvers.refilter()

    def refresh_filter_group(self, widget):
        self.filter_groups.refilter()

    def on_cell_group_toggled_liststore(self, widget, path, index):
        self.groupslist_treeview.set_cursor(path)
        model, iter = self.groupslist_treeview.get_selection().get_selected()
        model[iter][index] = not model[iter][index]
        for i in range(0, len(self.groups_list)):
            if self.groups_list[i][0] == model[iter][0]:
                self.groups_list[i][index] = model[iter][index]
                with open(f"/tmp/share_directory/groups/{self.extra_path}.json") as f:
                    data = json.load(f)
                    for group in data:
                        for key in group:
                            if key == model[iter][0]:
                                group[key][index-1] = self.groups_list[i][index]
                with open(f'/tmp/share_directory/groups/{self.extra_path}.json', 'w') as f:
                    json.dump(data, f)

    def __get_selection(self, selection):
        (model, iter) = selection.get_selected()
        self.selection = selection
        selected_value = model.get_value(iter, 0)
        self.extra_path = model.get_value(iter, 1)
        self.extra_path = ",".join(reversed(self.extra_path.split(",")))

        self.make_lists(self.extra_path, path=self.path)
        self.filter_uzvers.refilter()
        self.filter_groups.refilter()

    def visible_names_uzver(self, model, iter, data=None):
        search_query = self.entry_uzver.get_text().lower()
        if search_query == "" or search_query is None:
            return True
        value = model.get_value(iter, 0).lower()
        self.window.show_all()
        return True if value.startswith(search_query) else False

    def visible_names_groups(self, model, iter, data=None):
        search_query = self.entry_group.get_text().lower()
        if search_query == "":
            return True
        value = model.get_value(iter, 0).lower()
        return True if value.startswith(search_query) else False

    def make_lists(self, extra_path, path=""):
        dc_server_name = self.server_name.split(".")
        dc_separated = ''
        for d in dc_server_name[1:]:
            dc_separated += f'dc={d},'
        dc_separated = dc_separated[:-1]
        if os.path.exists(f"/tmp/share_directory/users/{extra_path}.json") and \
            os.path.exists(f'/tmp/share_directory/groups/{extra_path}.json'):
            if path != "":
                acls = subprocess.Popen(f'getfacl -p "{path}"',
                                        stdout=subprocess.PIPE, stderr=subprocess.PIPE,
                                        shell=True)

                acls_out = acls.communicate()[0].decode("utf-8").strip()
                users = re.findall(r'^user\:\S+\:.{3}', acls_out, re.MULTILINE + re.DOTALL)
                groups = re.findall(r'^group\:\S+\:.{3}', acls_out, re.MULTILINE + re.DOTALL)

                with open(f"/tmp/share_directory/users/{extra_path}.json", "r") as f:
                    user_data = json.load(f)
                with open(f"/tmp/share_directory/groups/{extra_path}.json", "r") as f:
                    group_data = json.load(f)
                if user_data:
                    self.users_list.clear()
                    for user in user_data:
                        for key in user:
                            flag_allowed_user = user[key][0]
                            flag_read_user = user[key][1]
                            flag_write_user = user[key][2]
                            flag_execute_user = user[key][3]
                            for uzver in users:
                                uzver = uzver.split(":")
                                if str(key).lower() in re.sub("\\\\040", " ", uzver[1]).lower():
                                    flag_allowed_user = True
                                    if "r" in uzver[2]:
                                        flag_read_user = True
                                    if "w" in uzver[2]:
                                        flag_write_user = True
                                    break
                            self.users_list.append(
                                [str(key), flag_allowed_user, flag_read_user, flag_write_user, flag_execute_user])
                if group_data:
                    self.groups_list.clear()
                    for group in group_data:
                        for key in group:
                            flag_allowed_group = group[key][0]
                            flag_read_group = group[key][1]
                            flag_write_group = group[key][2]
                            flag_execute_group = group[key][3]
                            for gzver in groups:
                                gzver = gzver.split(":")
                                if str(key).lower() in re.sub("\\\\040", " ", gzver[1]).lower():
                                    flag_allowed_group = True
                                    if "r" in gzver[2]:
                                        flag_read_group = True
                                    if "w" in gzver[2]:
                                        flag_write_group = True
                                    break
                            self.groups_list.append([str(key), flag_allowed_group, flag_read_group,
                                                                     flag_write_group, flag_execute_group])
            else:
                with open(f"/tmp/share_directory/users/{extra_path}.json", "r") as f:
                    user_data = json.load(f)
                with open(f"/tmp/share_directory/groups/{extra_path}.json", "r") as f:
                    group_data = json.load(f)
                if user_data:
                    self.users_list.clear()
                    for user in user_data:
                        for key in user:
                            self.users_list.append([str(key), user[key][0], user[key][1], user[key][2], user[key][3]])
                if group_data:
                    self.groups_list.clear()
                    for group in group_data:
                        for key in group:
                            self.groups_list.append(
                                [str(key), group[key][0], group[key][1], group[key][2], group[key][3]])

        else:
            ldapsearch_user = subprocess.Popen(['ldapsearch', '-Y', 'GSSAPI', '-H', f'ldap://{self.server_name}', '-b',
                                                f'{extra_path},{dc_separated}', "(&(objectCategory=person))", 'sAMAccountName', '-LLL',
                                                "-o", "ldif-wrap=no"], stdout=subprocess.PIPE,
                                               stderr=subprocess.PIPE)

            output, error = ldapsearch_user.communicate()

            ldapsearch_user = output.decode("utf-8").split("\n")
            temp_users_list = []

            para = []
            for i in range(0, len(ldapsearch_user)):
                if "dn:" in ldapsearch_user[i]:
                    para.append([ldapsearch_user[i], ldapsearch_user[i + 1]])
            clear_para = []
            for p in para:
                temp_mas = []
                if "dn: " in p[0]:
                    temp_mas.append(re.sub("dn: ", "", p[0]))
                elif "dn:: " in p[0]:
                    temp_mas.append(base64.b64decode(re.sub("dn:: ", "", p[0])).decode('utf8'))
                if "sAMAccountName: " in p[1]:
                    temp_mas.append(re.sub("sAMAccountName: ", "", p[1]))
                elif "sAMAccountName:: " in p[1]:
                    temp_mas.append(base64.b64decode(re.sub("sAMAccountName:: ", "", p[1])).decode('utf8'))
                clear_para.append(temp_mas)

            for line in clear_para:
                try:
                    temp_users_list.append(line[1])
                except Exception as e:
                    print(line)
            temp_users_list.sort(key=lambda v: v.lower())

            ldapsearch_group = subprocess.Popen(
                ['ldapsearch', '-Y', 'GSSAPI', '-H', f'ldap://{self.server_name}', '-b',
                 f'{extra_path},{dc_separated}', '(&(objectCategory=group))', 'name', '-LLL', "-o", "ldif-wrap=no"],
                stdout=subprocess.PIPE)
            ldapsearch_group = ldapsearch_group.communicate()[0].decode("utf-8").split("\n")

            temp_groups_list = []
            para = []
            for i in range(0, len(ldapsearch_group)):
                if "dn:" in ldapsearch_group[i]:
                    para.append([ldapsearch_group[i], ldapsearch_group[i + 1]])
            clear_para = []
            for p in para:
                temp_mas = []
                if "dn: " in p[0]:
                    temp_mas.append(re.sub("dn: ", "", p[0]))
                elif "dn:: " in p[0]:
                    temp_mas.append(base64.b64decode(re.sub("dn:: ", "", p[0])).decode('utf8'))
                if "name: " in p[1]:
                    temp_mas.append(re.sub("name: ", "", p[1]))
                elif "name:: " in p[1]:
                    temp_mas.append(base64.b64decode(re.sub("name:: ", "", p[1])).decode('utf8'))
                clear_para.append(temp_mas)

            print("###########################################")
            for line in clear_para:
                try:
                    if "Builtin" not in line[0]:
                        temp_groups_list.append(line[1])
                except Exception as e:
                    print(line)

            temp_groups_list.sort(key=lambda v: v.lower())
            self.users_list.clear()
            self.groups_list.clear()
            self.users_list_allowed = []
            self.groups_list_allowed = []
            if path != "":
                acls = subprocess.Popen(f'getfacl -p "{path}"',
                                        stdout=subprocess.PIPE, stderr=subprocess.PIPE,
                                        shell=True)

                acls_out = acls.communicate()[0].decode("utf-8").strip()
                users = re.findall(r'^user\:\S+\:.{3}', acls_out, re.MULTILINE + re.DOTALL)
                groups = re.findall(r'^group\:\S+\:.{3}', acls_out, re.MULTILINE + re.DOTALL)

                json_users = []
                json_groups = []

                for i in range(0, len(temp_users_list)):
                    name = re.sub("\w*\\\\", "", temp_users_list[i].strip())
                    flag_allowed_user = False
                    flag_read_user = False
                    flag_write_user = False
                    flag_execute_user = True
                    for uzver in users:
                        uzver = uzver.split(":")
                        if name.lower() in re.sub("\\\\040", " ", uzver[1]).lower():
                            flag_allowed_user = True
                            if "r" in uzver[2]:
                                flag_read_user = True
                            if "w" in uzver[2]:
                                flag_write_user = True
                            break
                    self.users_list.append([name, flag_allowed_user, flag_read_user, flag_write_user, flag_execute_user])
                    json_users.append({str(name): [flag_allowed_user, flag_read_user, flag_write_user, flag_execute_user]})
                for i in range(0, len(temp_groups_list)):
                    name = re.sub("\w*\\\\", "", temp_groups_list[i].strip())
                    flag_allowed_group = False
                    flag_read_group = False
                    flag_write_group = False
                    flag_execute_group = True
                    for gzver in groups:
                        gzver = gzver.split(":")
                        if name.lower() in re.sub("\\\\040", " ", gzver[1]).lower():
                            flag_allowed_group = True
                            if "r" in gzver[2]:
                                flag_read_group = True
                            if "w" in gzver[2]:
                                flag_write_group = True
                            break
                    self.groups_list.append(
                        [name, flag_allowed_group, flag_read_group, flag_write_group, flag_execute_group])
                    json_groups.append({str(name): [flag_allowed_group, flag_read_group, flag_write_group, flag_execute_group]})
                if len(json_users) > 0:
                    with open(f'/tmp/share_directory/users/{extra_path}.json', 'w') as f:
                        json.dump(json_users, f)
                if len(json_groups) > 0:
                    with open(f'/tmp/share_directory/groups/{extra_path}.json', 'w') as f:
                        json.dump(json_groups, f)
            else:
                json_users = []
                json_groups = []
                for i in range(0, len(temp_users_list)):
                    json_users.append({str(re.sub("\w*\\\\", "", temp_users_list[i].strip())): [False, False, False, True]})
                    self.users_list.append([re.sub("\w*\\\\", "", temp_users_list[i].strip()), False, False, False, True])
                for i in range(0, len(temp_groups_list)):
                    json_groups.append({str(re.sub("\w*\\\\", "", temp_groups_list[i].strip())): [False, False, False, True]})
                    self.groups_list.append(
                        [re.sub("\w*\\\\", "", temp_groups_list[i].strip()), False, False, False, True])
                os.system("echo '{}' " + f"> /tmp/share_directory/users/{extra_path}.json")
                os.system("echo '{}' " + f"> /tmp/share_directory/groups/{extra_path}.json")
                if len (json_users) > 0:
                    with open(f'/tmp/share_directory/users/{extra_path}.json', 'w') as f:
                        json.dump(json_users, f)
                if len(json_groups) > 0:
                    with open(f'/tmp/share_directory/groups/{extra_path}.json', 'w') as f:
                        json.dump(json_groups, f)
