#!/usr/bin/python3
# -*- coding: UTF-8 -*-
import configparser
import gettext
import gi
import locale
import os
import re
import subprocess

from share_directory import share_ipa
from share_directory import share_msad
from share_directory import share_wg

gi.require_version('Gtk', '3.0')
gi.require_version('Gdk', '3.0')
from gi.repository import Gtk, Gdk

t = gettext.translation('share_directory', "/usr/share/locale/")
t.install()
_ = t.gettext

builder = Gtk.Builder()
builder.set_translation_domain("share_directory")
LAYOUT_STYLE_LEGACY, LAYOUT_STYLE_NEW = range(2)

builder.add_from_file('/usr/share/share_directory/ui/share_directory.glade')
from share_directory.common import *
# from common import *
def custom_delete_msad(window, data):  # действие для подчистки многопоточности, оставляемой приложением
    os.system("rm -rf /tmp/share_directory")
    # the_dbus_starter.rules_tmp_firebird()
    Gtk.main_quit()


def main():
    win = InfoClass()
    if not os.geteuid() == 0:
        message = _('Changing rights is only available for Root user')
        win.print_error(message)
    else:
        screen = Gdk.Screen.get_default()
        provider = Gtk.CssProvider()
        provider.load_from_path("/usr/share/share_directory/ui/style.css")
        Gtk.StyleContext.add_provider_for_screen(screen, provider, Gtk.STYLE_PROVIDER_PRIORITY_APPLICATION)

        domain = get_domain_type()
        if len(domain) > 1:
            domain = domain[1]
        elif len(domain) == 1:
            domain = domain[0]
        if domain == "active-directory":
            if get_smbd_LIBACL():
                klist_out = subprocess.Popen(["klist"], stdout=subprocess.PIPE, stderr=subprocess.PIPE)
                out, errs = klist_out.communicate()
                if klist_out.returncode != 0:
                    if "No credentials cache found (filename: /tmp/krb5cc_" in errs.decode("utf-8"):
                        out = win.ticket_dialog()
                        if len(out) == 1:
                            if out[0]:
                                class_win = share_msad.DomainGUI()
                                class_win.window.connect("destroy", Gtk.main_quit)
                                Gtk.main()
                        elif len(out) == 2:
                            output = "\n".join(st for st in out[1])
                            win.print_error(output)
                    else:
                        win.print_error(errs.decode("utf-8").strip())
                else:
                    class_win = share_msad.DomainGUI()
                    class_win.window.connect("delete-event", custom_delete_msad)
                    Gtk.main()
            else:
                message = _('smb does not support ACL')
                win.print_error(message)
        elif domain == "ipa":
            comd = subprocess.Popen(["ipa", "user-find", "--all"],
                                    stdout=subprocess.PIPE, stderr=subprocess.PIPE, env={'LANG': 'C'})
            output, error = comd.communicate()
            error = error.decode('utf-8').strip()
            if error == "ipa: ERROR: Ticket expired":
                win.print_error(error)
            else:
                if get_smbd_LIBACL():
                    class_win = share_ipa.IpaGUI()
                    class_win.window.connect("destroy", Gtk.main_quit)
                    Gtk.main()
                else:
                    message = _('smb does not support ACL')
                    win.print_error(message)
        else:
            comd = subprocess.Popen(["samba-tool", "domain", "info", "127.0.0.1"],
                                    stdout=subprocess.PIPE, stderr=subprocess.PIPE, env={'LANG': 'C'})
            output, error = comd.communicate()
            if output:
                win.print_error(_("Launch on Samba Domain Controller is not allowed"))
            else:
                class_win = share_wg.LocalGUI()
                class_win.window.connect("destroy", Gtk.main_quit)
                Gtk.main()

if __name__ == "__main__":
    main()