import gettext
import json
import locale
import os, gi, re, configparser, subprocess
import base64
gi.require_version('Gtk', '3.0')
gi.require_version('Gdk', '3.0')
from gi.repository import Gtk, Gdk

t = gettext.translation('share_directory', "/usr/share/locale/")
t.install()
_ = t.gettext

builder = Gtk.Builder()
builder.set_translation_domain("share_directory")
LAYOUT_STYLE_LEGACY, LAYOUT_STYLE_NEW = range(2)

builder.add_from_file('/usr/share/share_directory/ui/share_directory.glade')
# builder_ad.add_from_file('ui/share_directory.glade')
from share_directory.common import *
from share_directory.ad_access_dialog import *
# from ad_access_dialog import *
# from common import *
# log_actions_available = common.log_actions_available
#

# log_prefixes_available = common.log_prefixes_available

class DomainGUI:
    def __init__(self):
        self.window = builder.get_object("main_window")
        self.window.set_title(_("Share dir in MS AD / Samba AD"))
        image = Gtk.Image.new_from_file("/usr/share/icons/hicolor/64x64/apps/share-directory.svg")
        image.set_pixel_size(32)
        self.window.set_icon(image.get_pixbuf())
        self.stack = builder.get_object("MainStack")
        self.stack.set_visible_child_name("msad_page")

        self.folders_treeview = builder.get_object("folders_treeview")
        self.folders_list = Gtk.ListStore(str, str)

        self.users_list = Gtk.ListStore(str, bool, bool, bool, bool)
        self.groups_list = Gtk.ListStore(str, bool, bool, bool, bool)

        self.entry_folder_path = builder.get_object("entry_folder_msad_path")

        self.button_choose_folder = builder.get_object("button_choose_folder_msad")
        self.button_choose_folder.connect("clicked", self.on_button_choose_folder_clicked)

        ###############################################

        self.groups_list_allowed = []
        self.users_list_allowed = []
        self.button_groups_and_users_msad_list = builder.get_object("button_groups_and_users_msad_list")
        self.button_groups_and_users_msad_list.connect("clicked", self.on_button_groups_and_users_msad_list_clicked)

        self.button_recursive = builder.get_object("button_recursive_msad")
        self.button_recursive.set_active(True)

        self.button_apply_settings = builder.get_object("button_apply_settings_msad")
        self.button_apply_settings.connect("clicked", self.on_button_apply_settings_clicked)

        ####################################################
        ####################################################

        self.log_actions_available_list = Gtk.ListStore(str, bool)
        self.log_actions_available_unsuccess_list = Gtk.ListStore(str, bool)
        self.log_prefixes_available_list = Gtk.ListStore(str, bool)

        global log_actions_available, log_prefixes_available
        for i in range(0, len(log_actions_available)):
            self.log_actions_available_list.append(log_actions_available[i])
            self.log_actions_available_unsuccess_list.append(log_actions_available[i])

        for i in range(0, len(log_prefixes_available)):
            self.log_prefixes_available_list.append(log_prefixes_available[i])

        self.entry_share_folder_path = builder.get_object("entry_share_folder_path_msad")

        self.button_choose_share_folder = builder.get_object("button_choose_share_msad")
        self.button_choose_share_folder.connect("clicked", self.on_button_choose_share_folder_clicked)

        self.entry_success = builder.get_object("entry_success_msad")

        self.button_log_actions_available_list = builder.get_object("button_log_actions_available_list_msad")
        self.button_log_actions_available_list.connect("clicked",
                                                       self.on_button_log_actions_available_list_clicked)

        self.entry_unsuccess = builder.get_object("entry_unsuccess_msad")

        self.button_log_actions_unsuccess_available_list = builder.get_object("button_log_actions_unsuccess_available_list_msad")
        self.button_log_actions_unsuccess_available_list.connect("clicked",
                                                                 self.on_button_log_actions_unsuccess_available_list_clicked)

        self.entry_prefix = builder.get_object("entry_prefix_msad")

        self.button_prefix_list = builder.get_object("button_prefix_list_msad")
        self.button_prefix_list.connect("clicked", self.on_button_button_prefix_list_clicked)

        self.protocols_combo = builder.get_object("protocols_combo_msad")

        self.button_apply_log_settings = builder.get_object("button_apply_log_settings_msad")
        self.button_apply_log_settings.connect("clicked", self.on_button_apply_log_settings_clicked)

        ####################################################
        ####################################################
        self.entry_path_to_remove = builder.get_object("entry_path_to_remove_msad")

        self.entry_group2 = builder.get_object("entry_group_remove_msad")

        self.entry_user2 = builder.get_object("entry_user_remove_msad")

        self.button_all = builder.get_object("button_all_msad")

        self.button_apply_remove_acl = builder.get_object("button_apply_remove_msad")
        self.button_apply_remove_acl.connect("clicked", self.on_button_apply_remove_acl_clicked)

        ###############################################

        self.entry_path_to_show_acl = builder.get_object("entry_path_to_show_rules_msad")
        self.button_choose_folder3 = builder.get_object("button_choose_folder_show_rules_msad")
        self.button_choose_folder3.connect("clicked", self.on_button_choose_folder2_clicked)

        ###############################################

        self.button_show_acl = builder.get_object("button_show_acl_msad")
        self.button_show_acl.connect("clicked", self.on_button_show_acl_clicked)

        ###############################################

        self.textview = builder.get_object("textview_msad")
        self.textbuffer = self.textview.get_buffer()
        self.textview.show()

        folders = get_share_folders("/etc/samba/smb.conf")
        for folder in folders:
            self.folders_list.append(folder)
        self.folders_treeview.set_model(self.folders_list)

        renderer_text = Gtk.CellRendererText()
        column_text = Gtk.TreeViewColumn(_("Shared folders"), renderer_text, text=0)
        self.folders_treeview.append_column(column_text)
        self.folders_treeview.get_selection().connect("changed", self.select_folder)
        self.folders_treeview.connect('button-press-event', self.on_treeview_doubleclicked)

        self.button_load_msad = builder.get_object("load_msad")
        self.button_load_msad.connect("clicked", self.on_button_load_clicked)

        self.button_remove_msad = builder.get_object("remove_msad")
        self.button_remove_msad.connect("clicked", self.on_button_remove_clicked)

        if not os.popen("systemctl list-unit-files | grep enabled | grep smb").readlines():
            os.system("systemctl enable smb")
        self.window.show_all()


    def check_netbios(self):
        wg_net = os.popen("net ads workgroup").readline().strip().split("Workgroup: ")[1]
        # then we check if we have unsusual netbios (WG in smb.conf != wg from net ads)
        wg_smb = get_artibute("/etc/samba/smb.conf", "global", "workgroup")
        if wg_smb != wg_net:
            self.fix_winbind_for_netbios()


    def on_treeview_doubleclicked(self, view, event):
        if event.type == Gdk.EventType.DOUBLE_BUTTON_PRESS and event.button == 1:
            (self.model, self.iter) = view.get_selection().get_selected()
            if self.model and self.iter:
                path = self.model.get_value(self.iter, 1)
                path = path[0:-1] if path[-1] == "/" else path
                self.entry_folder_path.set_text(path)
                self.entry_share_folder_path.set_text(path)
                self.entry_path_to_remove.set_text(path)
                self.entry_path_to_show_acl.set_text(path)

    def select_folder(self, selection):
        (self.model, self.iter) = selection.get_selected()
        self.folder_selection = selection

    def on_button_load_clicked(self, button):
        if hasattr(self, 'model') and hasattr(self, 'iter'):
            if self.model and self.iter:
                path = self.model.get_value(self.iter, 1)
                path = path[0:-1] if path[-1] == "/" else path
                self.entry_folder_path.set_text(path)
                self.entry_share_folder_path.set_text(path)
                self.entry_path_to_remove.set_text(path)
                self.entry_path_to_show_acl.set_text(path)
                self.folder_selection.unselect_all()

    def on_button_remove_clicked(self, button):
        try:
            (model, iter) = self.folder_selection.get_selected()
            counter_home = 0
            for section in model:
                if "/home/" in section[1]:
                   counter_home += 1
            if counter_home == 1:
                os.system("setsebool samba_enable_home_dirs 0")
                home_path = model.get_value(iter, 1).split("/")[1:]
                home_path = f"/home/{home_path[1]}"
                os.system(f"setfacl -b \"{home_path}\"")
            remove_old_section("/etc/samba/smb.conf", model.get_value(iter, 0))
            os.system(f"setfacl -b \"{str(model.get_value(iter, 1)[0:-1])}\"")
            os.system("systemctl restart smb")
            self.folders_list.remove(iter)
            self.folder_selection.unselect_all()
        except Exception as e:
            print(e)

    def on_button_choose_folder_clicked(self, button):
        win = InfoClass()
        self.entry_folder_path.set_text(win.choose_folder_dialog(self))

    def on_button_choose_folder2_clicked(self, button):
        win = InfoClass()
        self.entry_path_to_show_acl.set_text(win.choose_folder_dialog(self))

    def on_button_groups_and_users_msad_list_clicked(self, button):
        path = self.entry_folder_path.get_text()
        win = UserandGroupViewer(path=path) if path != None or path != "" else UserandGroupViewer()
        win.window.connect("destroy", Gtk.main_quit)
        Gtk.main()

    def on_button_apply_settings_clicked(self, button):
        if self.create_folder():
            if self.add_rules():
                output = os.popen("realm list | grep 'client-software: sssd'").readlines()
                if len(output) > 0:
                    do_changes_in_nsswitch()
                print("#########")
                self.write_to_smb(self.entry_folder_path.get_text())
                self.selinux_configure()
                win = InfoClass()
                success = _("Folder configuration successfull")
                self.entry_share_folder_path.set_text(self.entry_folder_path.get_text())
                self.entry_path_to_remove.set_text(self.entry_folder_path.get_text())
                self.entry_path_to_show_acl.set_text(self.entry_folder_path.get_text())
                win.print_info(success)

    def selinux_configure(self):
        output = os.popen("getenforce").readlines()[0]
        output = output.strip()
        path = self.entry_folder_path.get_text()
        win = InfoClass()
        if output == "Enforcing":
            if path != "":
                if not os.popen(f"semanage fcontext --list \"{path}\" | grep samba_share_t").readlines():
                    os.system(f"semanage fcontext -a -t samba_share_t {selinx_patch_change(path)}")
                    os.system(f"restorecon -R -v {selinx_patch_change(path)}")
                if "off" in os.popen("getsebool samba_export_all_rw").readline():
                    os.system("setsebool -P samba_export_all_rw 1")
                if "/home/" in path:
                    if "off" in os.popen("getsebool samba_enable_home_dirs").readline():
                        os.system("setsebool -P samba_enable_home_dirs 1")
            else:
                win.print_info(_('Type path'))

    def on_button_apply_remove_acl_clicked(self, button):
        delete_success = _("Rules deleted successfully")
        if self.button_all.get_active():
            if self.remove_all_rules():
                win = InfoClass()
                win.print_info(delete_success)
        else:
            if self.remove_rules():
                win = InfoClass()
                win.print_info(delete_success)

    def on_button_show_acl_clicked(self, button):
        self.get_rules()

    def create_folder(self):
        path = self.entry_folder_path.get_text()
        path_to = path
        win = InfoClass()
        if path != "":
            if path[0] != "/":
                path_to = "/" + path
                self.entry_folder_path.set_text(path_to)
            if not os.path.exists(f"{str(path_to)}"):
                os.makedirs(f'{str(path_to)}') 
            return True
        else:
            win.print_info(_('Type path'))
            return False

    def remove_rules(self):
        path = self.entry_path_to_remove.get_text()
        path_to = path
        name = self.entry_user2.get_text()
        group = self.entry_group2.get_text()
        win = InfoClass()
        if path != "":
            if path[0] != "/":
                path_to = "/" + path
                self.entry_path_to_remove.set_text(path_to)
            if not os.path.exists(path_to):
                win.print_error(_("Path doesn't exist"))
                return False
            else:
                if name == "" and group == "":
                    win.print_info(_('Specify whose rights you want to remove'))
                    return False
                else:
                    if name != "":
                        strk = f'setfacl -x u:"{name}" \"{path}\"'
                        output = os.system(strk)
                        if output != 0:
                            win.print_error(_('An error occurred while deleting permissions, '
                                              'please check that the username is correct'))
                            return False
                        strk = f'setfacl -x d:u:"{name}" \"{path}\"'
                        os.system(strk)
                        output = os.system(strk)
                        if output != 0:
                            win.print_error(_('An error occurred while deleting permissions, '
                                              'please check that the username is correct'))
                            return False
                    if group != "":
                        strk = f'setfacl -x g:"{group}" \"{path}\"'
                        os.system(strk)
                        output = os.system(strk)
                        if output != 0:
                            win.print_error(_('An error occurred while deleting permissions, '
                                              'please check that the groupname is correct'))
                            return False
                        strk = f'setfacl -x d:g:"{group}" \"{path}\"'
                        os.system(strk)
                        output = os.system(strk)
                        if output != 0:
                            win.print_error(_('An error occurred while deleting permissions, '
                                              'please check that the username is correct'))
                            return False
                    return True
        else:
            win.print_info(_('Type path'))
            return False

    def remove_all_rules(self):
        path = self.entry_path_to_remove.get_text()
        path_to = path
        win = InfoClass()
        if path != "":
            if path[0] != "/":
                path_to = "/" + path
                self.entry_path_to_remove.set_text(path_to)
            if os.path.exists(path_to):
                strk = f"setfacl -b \"{str(path_to)}\""
                os.system(strk)
                return True
            else:
                win.print_error(_("Path doesn't exist"))
                return False
        else:
            win.print_info(_('Type path'))
            return False

    def write_to_smb(self, path):
        mas = path.split("/")
        folder = mas[len(mas) - 1]
        os.system("cp /etc/samba/smb.conf /etc/samba/smb.conf.$(date '+%F-%T')")
        set_artibute('/etc/samba/smb.conf', 'global', "vfs objects", "acl_xattr")
        set_artibute('/etc/samba/smb.conf', 'global', "map acl inherit", "yes")
        set_artibute('/etc/samba/smb.conf', 'global', "store dos attributes", "yes")
        set_artibute('/etc/samba/smb.conf', 'global', "dedicated keytab file", "/etc/krb5.keytab")
        set_artibute('/etc/samba/smb.conf', 'global', "kerberos method", "secrets and keytab")

        if not get_section("/etc/samba/smb.conf", folder):
            add_new_section('/etc/samba/smb.conf', folder)
            if path[len(path) - 1] != "\\":
                set_artibute('/etc/samba/smb.conf', folder, "path", f"{path}/")
            else:
                set_artibute('/etc/samba/smb.conf', folder, "path", path)
            set_artibute('/etc/samba/smb.conf', folder, "read only", "no")
            set_artibute('/etc/samba/smb.conf', folder, "browseable", "yes")
        else:
            if path[len(path) - 1] != "\\":
                set_artibute('/etc/samba/smb.conf', folder, "path", f"{path}/")
            else:
                set_artibute('/etc/samba/smb.conf', folder, "path", path)
            set_artibute('/etc/samba/smb.conf', folder, "read only", "no")
            set_artibute('/etc/samba/smb.conf', folder, "browseable", "yes")
        flag_exists = False
        for fol in self.folders_list:
            if folder == fol[0]:
                flag_exists = True
        if not flag_exists:
            self.folders_list.append([folder, path])
        os.system("systemctl restart smb")

    def add_rules(self):
        path = self.entry_folder_path.get_text()
        win = InfoClass()
        if os.path.exists("/tmp/share_directory/"):
            for filename in os.listdir("/tmp/share_directory/users"):
                f = os.path.join("/tmp/share_directory/users", filename)
                with open(f, "r") as json_file:
                    data = json.load(json_file)
                    for user in data:
                        for key in user:
                            break_flag = False
                            for user_list in self.users_list_allowed:
                                if key == user_list[0]:
                                    break_flag = True
                                    break
                            if not break_flag:
                                if user[key][0]:
                                    self.users_list_allowed.append([key, user[key][0], user[key][1], user[key][2], user[key][3]])
            for filename in os.listdir("/tmp/share_directory/groups"):
                f = os.path.join("/tmp/share_directory/groups", filename)
                with open(f, "r") as json_file:
                    data = json.load(json_file)
                    for group in data:
                        for key in group:
                            break_flag = False
                            for group_list in self.groups_list_allowed:
                                if key == group_list[0]:
                                    break_flag = True
                                    break
                            if not break_flag:
                                if group[key][0]:
                                    self.groups_list_allowed.append([key, group[key][0], group[key][1], group[key][2], group[key][3]])
            if len(self.users_list_allowed) == 0 and len(self.groups_list_allowed) == 0:
                win.print_info(_('Specify to whom you want to assign rights'))
            else:
                recursive = ""
                if self.button_recursive.get_active():
                    recursive = "-R"
                domain = get_domain_name()
                path_root = path.split("/")[1:]
                strk = f"setfacl -b {str(path)}"
                os.system(strk)
                print(path_root)
                if path != "" and len(self.groups_list_allowed) > 0:
                    strk = f'chown {recursive} root: "{path}" && chmod 2770 "{path}" '
                    for group_member in self.groups_list_allowed:
                        group = group_member[0]
                        group = re.sub("\$", "\\$", group)
                        mas = ["-", "-", "x"]
                        if group_member[2]:
                            mas[0] = "r"
                        if group_member[3]:
                            mas[1] = "w"
                        # if group_member[4]:
                        #     mas[2] = "x"
                        permissions = "".join([str(p) for p in mas])
                        if len(path_root) == 1:
                            strk += f'&& setfacl {recursive} -m default:group:"{str(domain)}\\\\\\{group}":{permissions} "{path}" ' \
                                    f'&& setfacl {recursive} -m group:"{str(domain)}\\\\\\{group}":{permissions}"{path}" '
                        else:
                            strk += f'&& setfacl {recursive} -m default:group:"{str(domain)}\\\\{group}":{permissions} "{path}" ' \
                                    f'&& setfacl {recursive} -m group:"{str(domain)}\\\\\\{group}":{permissions} "{path}" '
                            temp_path = ""
                            for i in range(0, len(path_root) - 1):
                                temp_path += f" \"/{'/'.join(path_root[0:i + 1])}\""
                            strk += f'&& setfacl -m group:"{str(domain)}\\\\\\{group}":{permissions} {temp_path} '
                    print("group change\n#########", strk)
                    output = os.system(f"{strk}")
                    if output != 0:
                        win.print_error(_("An error occurred while applying rights, "
                                          "check that the user and group names are correct"))
                        return False
                if path != "" and len(self.users_list_allowed) > 0:
                    recursive = ""
                    if self.button_recursive.get_active():
                        recursive = "-R"
                    domain = get_domain_name()
                    path_root = path.split("/")[1:]
                    strk = f'chown {recursive} root: "{path}" && chmod 2770 "{path}" '
                    for user_member in self.users_list_allowed:
                        user = user_member[0]
                        user = re.sub("\$", "\\$", user)
                        mas = ["-", "-", "x"]
                        if user_member[2]:
                            mas[0] = "r"
                        if user_member[3]:
                            mas[1] = "w"
                        # if user_member[4]:
                        #     mas[2] = "x"
                        permissions = "".join([str(p) for p in mas])
                        if len(path_root) == 1:
                            strk += f'&& setfacl {recursive} -m default:user:"{str(domain)}\\\\\\{user}":{permissions} "{path}" ' \
                                    f'&& setfacl {recursive} -m user:"{str(domain)}\\\\\\{user}":{permissions} "{path}" '
                        else:
                            strk += f'&& setfacl {recursive} -m default:user:"{str(domain)}\\\\{user}":{permissions} "{path}" ' \
                                    f'&& setfacl {recursive} -m user:"{str(domain)}\\\\\\{user}":{permissions} "{path}" '
                            temp_path = ""
                            for i in range(0, len(path_root) - 1):
                                temp_path += f" \"/{'/'.join(path_root[0:i + 1])}\""
                            strk += f'&& setfacl -m user:"{str(domain)}\\\\\\{user}":{permissions} {temp_path} '
                    print("name change\n#########", strk)
                    output = os.system(f"{strk}")
                    if output != 0:
                        win.print_error(_("An error occurred while applying rights, "
                                          "check that the user and group names are correct"))
                        return False
                return True
        else:
            win.print_info(_('Specify to whom you want to assign rights'))

    def get_rules(self):
        path = self.entry_path_to_show_acl.get_text()
        path_to = path
        win = InfoClass()
        if path != "":
            if path[0] != "/":
                path_to = "/" + path
                self.entry_path_to_show_acl.set_text(path_to)
            if os.path.exists(path_to):
                end_text = os.popen(f"getfacl -p \"{path_to}\"").readlines()
                strk = "".join([str(k) for k in end_text])
                self.textbuffer.set_text(str(strk))
            else:
                win.print_error(_("Path doesn't exist"))

    def on_button_choose_share_folder_clicked(self, button):
        win = InfoClass()
        self.entry_share_folder_path.set_text(win.choose_folder_dialog(self))

    def on_button_log_actions_available_list_clicked(self, button):
        win = InfoClass()
        log_actions = _("Log actions")
        selected_actions = _("Selected actions")
        if win.call_dialog(self.log_actions_available_list, log_actions,
                           log_actions, selected_actions, "", "", 390, 300):
            text = ""
            for i in range(0, len(self.log_actions_available_list)):
                if self.log_actions_available_list[i][1]:
                    text += f"{self.log_actions_available_list[i][0]}," if i < len(self.log_actions_available_list) - 1 \
                        else f"{self.log_actions_available_list[i][0]}"
            if len(text) != 0:
                if text[-1] == ",":
                    text = text[:-1]
            else:
                text = "none"
            self.entry_success.set_text(text)

    def on_button_log_actions_unsuccess_available_list_clicked(self, button):
        win = InfoClass()
        log_actions = _("Log actions")
        selected_actions = _("Selected actions")
        if win.call_dialog(self.log_actions_available_unsuccess_list, log_actions,
                           log_actions, selected_actions, "", "", 390, 300):
            text = ""
            for i in range(0, len(self.log_actions_available_unsuccess_list)):
                if self.log_actions_available_unsuccess_list[i][1]:
                    text += f"{self.log_actions_available_unsuccess_list[i][0]}," if i < len(
                        self.log_actions_available_unsuccess_list) - 1 else f"{self.log_actions_available_unsuccess_list[i][0]}"
            if len(text) != 0:
                if text[-1] == ",":
                    text = text[:-1]
            else:
                text = "none"
            self.entry_unsuccess.set_text(text)

    def on_button_button_prefix_list_clicked(self, button):
        win = InfoClass()
        log_prefixes = _("Log prefixes")
        selected_prefixes = _("Selected prefixes")
        if win.call_dialog(self.log_prefixes_available_list, log_prefixes,
                           log_prefixes, selected_prefixes, "", "", 390, 300):
            text = ""
            for i in range(0, len(self.log_prefixes_available_list)):
                if self.log_prefixes_available_list[i][1]:
                    text += f"{self.log_prefixes_available_list[i][0]}," if i < len(self.log_prefixes_available_list) - \
                                                                            1 else f"{self.log_prefixes_available_list[i][0]}"
            if len(text) != 0:
                if text[-1] == ",":
                    text = text[:-1]
            self.entry_prefix.set_text(text)

    def on_button_apply_log_settings_clicked(self, button):
        prefix = self.entry_prefix.get_text()
        prefix = re.sub("%", "%%", prefix)
        success = self.entry_success.get_text()
        unsuccess = self.entry_unsuccess.get_text()
        path = self.entry_share_folder_path.get_text()
        priority = self.protocols_combo.get_active_text()
        local_number = get_level()
        win = InfoClass()
        mas = path.split("/")
        folder = mas[len(mas) - 1]
        if get_section("/etc/samba/smb.conf", folder):
            if prefix != "" and success != "" and unsuccess != "" and priority != "":

                grep_level = os.popen(f'grep "{folder}.log" /etc/rsyslog.conf').readlines()
                if len(grep_level) > 0:
                    set_artibute(path="/etc/samba/smb.conf", section=folder, setting="vfs objects",
                                 value="full_audit")
                    set_artibute(path="/etc/samba/smb.conf", section=folder, setting="full_audit:prefix",
                                 value=f"{prefix}")
                    set_artibute(path="/etc/samba/smb.conf", section=folder, setting="full_audit:failure",
                                 value=f"{unsuccess}")
                    set_artibute(path="/etc/samba/smb.conf", section=folder, setting="full_audit:success",
                                 value=f"{success}")
                    set_artibute(path="/etc/samba/smb.conf", section=folder, setting="full_audit:facility",
                                 value=f"local{local_number}")
                    set_artibute(path="/etc/samba/smb.conf", section=folder, setting="full_audit:priority",
                                 value=f"{priority}")
                    # opening the file in read mode
                    file = open("/etc/rsyslog.conf", "r")
                    replacement = ""
                    # using the for loop
                    for line in file:
                        line = line.strip()
                        if f"{folder}.log" in line:
                            changes = f"local{local_number}.{priority}                                                " \
                                      f"-/var/log/samba/{folder}.log"
                        else:
                            changes = line
                        replacement = replacement + changes + "\n"

                    file.close()
                    if not os.path.exists(f"/var/log/samba/{folder}.log"):
                        os.system(f"touch /var/log/samba/{folder}.log")
                    # opening the file in write mode
                    file = open("/etc/rsyslog.conf", "w")
                    file.write(replacement)
                    file.close()
                    os.system("sed -i 's|%%|%|g' /etc/samba/smb.conf")
                    os.system("systemctl restart smb rsyslog")
                    win.print_info(_('Folder setup completed successfully.\n'
                                     'Please reboot for the settings to take effect.'))
                elif local_number == "":
                    local_number = 0
                    set_artibute(path="/etc/samba/smb.conf", section=folder, setting="vfs objects",
                                 value="full_audit")
                    set_artibute(path="/etc/samba/smb.conf", section=folder, setting="full_audit:prefix",
                                 value=f"{prefix}")
                    set_artibute(path="/etc/samba/smb.conf", section=folder, setting="full_audit:failure",
                                 value=f"{unsuccess}")
                    set_artibute(path="/etc/samba/smb.conf", section=folder, setting="full_audit:success",
                                 value=f"{success}")
                    set_artibute(path="/etc/samba/smb.conf", section=folder, setting="full_audit:facility",
                                 value=f"local{local_number + 1}")
                    set_artibute(path="/etc/samba/smb.conf", section=folder, setting="full_audit:priority",
                                 value=f"{priority}")
                    os.system(
                        f"echo 'local{local_number + 1}.{priority}                                                "
                        f"-/var/log/samba/{folder}.log' >> /etc/rsyslog.conf")
                    if not os.path.exists(f"/var/log/samba/{folder}.log"):
                        os.system(f"touch /var/log/samba/{folder}.log")
                    os.system("sed -i 's|%%|%|g' /etc/samba/smb.conf")
                    os.system("systemctl restart smb rsyslog")

                    win.print_info(_('Folder setup completed successfully.\n'
                                     'Please reboot for the settings to take effect.'))
                elif 0 <= local_number <= 5:  # до local5, тк local5+1 = local6 т.е. уже максимум,
                    # local7 - занят системой, local8+ уже не поддерживается
                    set_artibute(path="/etc/samba/smb.conf", section=folder, setting="vfs objects",
                                 value="full_audit")
                    set_artibute(path="/etc/samba/smb.conf", section=folder, setting="full_audit:prefix",
                                 value=f"{prefix}")
                    set_artibute(path="/etc/samba/smb.conf", section=folder, setting="full_audit:failure",
                                 value=f"{unsuccess}")
                    set_artibute(path="/etc/samba/smb.conf", section=folder, setting="full_audit:success",
                                 value=f"{success}")
                    set_artibute(path="/etc/samba/smb.conf", section=folder, setting="full_audit:facility",
                                 value=f"local{local_number + 1}")
                    set_artibute(path="/etc/samba/smb.conf", section=folder, setting="full_audit:priority",
                                 value=f"{priority}")
                    os.system(
                        f"echo 'local{local_number + 1}.{priority}                                                "
                        f"-/var/log/samba/{folder}.log' >> /etc/rsyslog.conf")
                    os.system("sed -i 's|%%|%|g' /etc/samba/smb.conf")
                    if not os.path.exists(f"/var/log/samba/{folder}.log"):
                        os.system(f"touch /var/log/samba/{folder}.log")
                    os.system("systemctl restart smb rsyslog")
                    win.print_info(_('Folder setup completed successfully.\n'
                                     'Please reboot for the settings to take effect.'))
                else:
                    win.print_error(_('A maximum of 7 network folders are available for logging.\n'
                                    'You need to disable logging for the previous network folder.\n'
                                    'Files: /etc/samba/smb.conf and /etc/rsyslog.conf'))

class WinbindDialog:
    def __init__(self, wg, net_wg):
        super(WinbindDialog, self).__init__()
        self.builder_ad = Gtk.Builder()
        self.builder_ad.add_from_file('/usr/share/share_directory/ui/templates.glade')
        # self.builder_ad.add_from_file('/home/wolandius/git_projects/share_directory/data/templates.glade')
        self.builder_ad.set_translation_domain("share_directory")
        self.window = self.builder_ad.get_object("winbind_window")
        self.admin_login_entry = self.builder_ad.get_object("admin_login_entry")
        self.admin_password_entry = self.builder_ad.get_object("admin_password_entry")
        self.apply_button = self.builder_ad.get_object("apply_button")
        self.apply_button.connect("clicked", self.on_save_button_access_window_clicked)
        self.close_button = self.builder_ad.get_object("close_button")
        self.close_button.connect("clicked", self.on_close_button_clicked)
        self.wg = wg
        self.net_wg = net_wg
        self.window.show_all()

    def on_apply_button_clicked(self, button):
        login = self.admin_login_entry.get_text()
        password = self.admin_password_entry.get_text()
        os.system("cp /etc/samba/smb.conf /etc/samba/smb.conf.$(date '+%F-%T')")
        set_artibute('/etc/samba/smb.conf', 'global', f"idmap config {self.wg} : backend", "sss")
        set_artibute('/etc/samba/smb.conf', 'global', f"idmap config {self.wg} : range", "sss")
        set_artibute('/etc/samba/smb.conf', 'global', f"workgroup", f"{self.net_wg}")
        output = os.popen(f"echo {password} | net ads join -U {login}").readline()
        if "Joined" in output:
            win = InfoClass()
            win.print_info(_("Winbind is active") )
        else:
            win = InfoClass()
            win.print_error(_("An error occurred")+f" {output}")


        self.window.destroy()
    def on_close_button_clicked(self, button):
        self.window.destroy()
